QGIS Application - Bug report #19956
Update SQL layer results in invalid SQL expression
2018-09-26 02:32 PM - Lars Kellogg-Stedman

Status: Closed

Priority: Normal

Assignee: Alessandro Pasotti

Category: DB Manager

Affected QGIS version:3.3(master) Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 27778
Description

It looks like the fix for #19843 resulted in a new problem.

With revision 2085714, selecting "Update SQL Layer..." still produces a database error, although a slightly different one:

near "(": syntax error

And instead of treating the existing query as a table name, it is now trying to surround the entire expression with parentheses:

(select ... from ...)

This appears to be an artifact of how the query expression is stored; looking at the layer source, | see:

dbname='lic.db' table="(select ... from ...)" (geom) sql=

Those parentheses result in the syntax error when trying to execute the expression in the DB manager.

Associated revisions

Revision 94ded32f - 2018-09-27 08:01 AM - Alessandro Pasotti

[db-manager] Allow multiline filters in sgl window

Fixes #19956 - Update SQL layer results in invalid SQL expression

History

#1 - 2018-09-26 02:45 PM - Alessandro Pasotti
- Assignee set to Alessandro Pasotti

#2 - 2018-09-26 02:47 PM - Alessandro Pasotti

To be sure | can reproduce exactly your scenario, can you please describe the steps starting from an unfiltered layer?

#3 - 2018-09-26 06:59 PM - Lars Kellogg-Stedman

Sure.

1. | started with the MASSGIS TOWNS_POLY .shp dataset from https://docs.digital.mass.gov/dataset/massgis-data-community-boundaries-towns
2. | opened this shapefile in QGIS and saved it as a Spatialite datasource
3. | used SpatialLite -> New Connection to open the resulting data source
4. | double clicked on the "towns" table to add it to the project
5. | selected "Update SQL Layer..." after right clicking on the "towns" layer
6. | updated the query to look like:
SELECT b.town as town, b.town_id as town_id, b.geometry as geometry
FROM
"towns" as a
join "towns" as b on b.town = '"AMHERST' or st_touches(a.geometry, b.geometry)
where
a.town = 'AMHERST'

7. | selected "Update" and closed the database manager
8. | once again selected "Update SQL Layer..." from the layer menu.
9. This resulted in the syntax error, and the query now looks like:
(SELECT b.town as town, b.town_id as town_id, b.geometry as geometry
FROM
"towns" as a
join "towns" as b on b.town = '"AMHERST' or st_touches(a.geometry, b.geometry)
where a.town = 'AMHERST'

I've noticed something interesting: if | keep the entire sql expression on a single line like this:
SELECT b.town as town, b.town_id as town_id, b.geometry as geometry FROM "towns" as a join "towns" as b on b.town = 'AMHERST' or

st_touches(a.geometry, b.geometry) where a.town = 'AMHERST'

..then | don't get the error when subsequently editing it, and it never gets those extra parentheses.

#4 - 2018-09-27 07:30 AM - Alessandro Pasotti

Thanks for the information!
I think | know where's the issue, working on it today.

#5 - 2018-09-27 08:31 AM - Alessandro Pasotti
- Status changed from Open to In Progress
- Pull Request or Patch supplied changed from No to Yes

https://github.com/qgis/QGIS/pull/8037

#6 - 2018-09-27 09:18 AM - Anonymous
- % Done changed from 0 to 100

- Status changed from In Progress to Closed
Applied in changeset commit:qgis|94ded32f4ee548c3fbc798b2fd81fd81c8cal 1bf.
